<%-- Copyright (c) 2001 by SAS Institute Inc., Cary, NC 27513 --%>
<%@ page errorPage="../Query/QueryErr.jsp" %>
<%@ page import="java.io.*,java.util.*" %>
<%@ page import="com.sas.query.*" %>
<%@ page import="com.sas.query.app.*" %>
<%@ page import="com.sas.query.datasources.*" %>
<%@ page import="com.sas.query.models.*" %>
<%@ page import="com.sas.query.models.Expression" %>
<%@ page import="com.sas.query.parser.*" %>
<%@ page import="com.sas.query.visuals.*" %>
<%@ page import="com.sas.hrv.*" %>
<%@ page import="com.sas.rmi.Connection" %>
<%@ page import="com.sas.collection.StringCollection" %>
<%@ page import="com.sas.servlet.beans.*" %>
<%@ page import="com.sas.servlet.beans.html.*" %>
<%@ include file="../Jsp/HRVLoginInclude.jsp" %>
<%@ include file="../Query/QueryInclude.jsp" %>
<% 
   VisMsg bundle = (VisMsg)request.getAttribute("resources");
   String m_pageLabel       = (String)request.getAttribute( "pageLabel" );
   String m_selectColumnLabel   = bundle.getString( "FilterBuilder.SelectAColumnLabel.txt" );
   String m_setOperationLabel   = bundle.getString( "FilterBuilder.SetOperationLabel.txt" );
   String m_enterValueLabel = bundle.getString( "FilterBuilder.EnterValueLabel.txt" );
   String m_clearLabel      = bundle.getString( "FilterBuilder.ClearLabel.txt" );
   String m_clearButtonLabel    = bundle.getString( "FilterBuilder.ClearButtonLabel.txt" );
   String m_clearTipText    = bundle.getString( "FilterBuilder.ClearButtonToolTip.txt" );
   String m_notBoxLabel     = bundle.getString( "FilterBuilder.NotButton.txt" );
   String m_valuesTipLabel  = bundle.getString( "Common.TipHelpLabel.txt" );
   String m_valuesButtonLabel   = bundle.getString( "FilterBuilder.ValuesButtonLabel.txt" );
   String m_valuesTipText   = bundle.getString( "FilterBuilder.ValuesButtonToolTip.txt" );
   String m_moreFiltersLabel    = bundle.getString( "FilterBuilder.MoreFilters.txt" );
   String m_moreFiltersTipText  = bundle.getString( "FilterBuilder.MoreFiltersToolTip.txt" );
   String m_tipHelpLabel    = bundle.getString( "Common.TipHelpLabel.txt");
   String m_dateFormatTipText   = bundle.getString( "FilterBuilder.DateFormatTip.txt" );
   String m_noColumnSelectedMsg = bundle.getString( "FilterBuilder.Message.NoColumnSelected.txt" );
   String m_incompleteFilterMsg = bundle.getString( "FilterBuilder.Message.IncompleteFilter.txt" );
   String m_queryLimit = bundle.getString( "FilterBuilder.QueryLimit.txt" );
   String m_queryLimitMsg = bundle.getString( "FilterBuilder.AddtlLimitMsg.txt" );

   int linesToShow = ((Integer)request.getAttribute("linesToShow")).intValue();
   String hideQueryLimit = request.getParameter("hideQueryLimit");

   StringCollection andOrModel = (StringCollection)request.getAttribute("model.andOr");
   //StringCollection[] columnModels = (StringCollection[])request.getAttribute("model.columns");
   StringCollection[] conditionalModels = (StringCollection[])request.getAttribute("filter.conditionalModels");
   String queryObs = request.getParameter("queryObs");
   if (queryObs == null) {
        TableList tablesInModel = m_query.getTables();  //the list of tables in the model
        //look at the first table in the model.
        com.sas.query.models.Table table = tablesInModel.elementAt(0);
        HRVDataSourceTable hrvDST = (HRVDataSourceTable)table.getDataSourceTable();
        queryObs = hrvDST.getQueryObs();
    }
    if (queryObs == null)
    queryObs = "";

   //Find the index of the default operator to be selected when the user
   //  chooses a column.
   int indexOfDefOperator = -1;
   indexOfDefOperator = conditionalModels[0].getIndex((String)request.getAttribute("defaultOperator"), 1);
   if (indexOfDefOperator < 0)
      indexOfDefOperator = 1;

%>
<HTML>
<HEAD>
   <%@ include file="../Jsp/HRVHeadInclude.jsp"%>
   <SCRIPT>
   //called when user changes column in selection box
   function OnChangeColumn(i) {
      //get references to form elements
      colChoice = document.forms["initQry"].elements["item"+i+".column"];
      operator  = document.forms["initQry"].elements["item"+i+".operator"];
      operand1  = document.forms["initQry"].elements["item"+i+".operand1"];

      //if non-blank was selected, then select default operator if needed
      if (colChoice.selectedIndex != 0) {
     //if operator was blank, then set it to default operator 
     if (operator.selectedIndex == 0) { operator.selectedIndex = <%= indexOfDefOperator %>; }
      }
      //we probably want to blank out the operand1 value anyway.  the value
      //for 1 column is not likely to work as value for another...
      operand1.value = "";
   }

   function ClearRow(i) {
      //get references to form elements
      colChoice = document.initQry.elements["item"+i+".column"];
      linkChoice= document.initQry.elements["item"+i+".link"];
      notBox    = document.initQry.elements["item"+i+".not"];
      operator  = document.initQry.elements["item"+i+".operator"];
      operand1  = document.initQry.elements["item"+i+".operand1"];
      
      openparen  = document.initQry.elements["item"+i+".openparen"];
      closeparen  = document.initQry.elements["item"+i+".closeparen"];      

      if (linkChoice != null) { linkChoice.selectedIndex = 0; }
      colChoice.selectedIndex = 0;
      notBox.checked = false;
      operator.selectedIndex = 0;
      operand1.value = "";
      
      openparen.selectedIndex = 0;
      closeparen.selectedIndex = 0;
   }

   var IE = (document.all) ? 1 : 0;
   var NS = (document.layers) ? 1 : 0;
   chooserWin = null;       //handle to the value selector window

   function popUp( loc, w, h, menubar ) {
      if( w == null ) { w = 550; }
      if( h == null ) { h = 350; }
      if( menubar == null || menubar == false ) {
     menubar = "";
      } else {
     menubar = "menubar,";
      }

      if( NS ) { w += 50; }
      // Need the var or else IE4 blows up not recognizing chooserWin
      chooserWin = window.open(loc,'editWin', menubar + 'resizable,scrollbars,width=' + w + ',height=' + h+',status');
      //if( !chooserWin.opener )
     //chooserWin.opener = window;
      chooserWin.focus(); //causing intermittent errors
   }

   function popUpLarge( loc, menubar ) {
      if( menubar == null ) { menubar = false; }
      popUp( loc, 700, 500, menubar );
   }

   function ShowValues(index) {
      colChoice = document.initQry.elements["item"+index+".column"];
      
      if (colChoice.selectedIndex == 0) {
         alert("<%= htmlEncode(m_noColumnSelectedMsg) %>");
      } else {
     popUp("../Query/ValueSelector.jsp?sessionkey=<%= m_sessionKey %>&item="+index);
      }
   }

   function OnChangeOperator(index) {
      //check to see if the value chooser is around
      if (chooserWin != null && chooserWin.closed == false) {
     colChoice  = document.initQry.elements["item"+index+".column"];
     operator   = document.initQry.elements["item"+index+".operator"];
     operand1   = document.initQry.elements["item"+index+".operand1"];

     if (operator.value == 'IN') {
        chooserWin.OnSwitchToMulti();
     } else {
        chooserWin.OnSwitchToSingle();
     }
      }
   }
   </SCRIPT>
</HEAD>
<BODY CLASS="bodyContents">

<CENTER><H1><%= m_pageLabel %></H1></CENTER>
<TABLE BORDER=0 WIDTH="100%" HEIGHT="100%">
<TR ALIGN=CENTER><TD VALIGN=CENTER>
<FORM NAME="initQry" ACTION="<%= request.getAttribute("formURL") %>" METHOD=POST>
<INPUT TYPE=HIDDEN NAME="sessionkey" VALUE="<%= m_sessionKey %>">
<INPUT TYPE=HIDDEN NAME="intAction" VALUE="">
<INPUT TYPE=HIDDEN NAME="itemCount" VALUE="<%= linesToShow %>">

<TABLE>
<TR><TD><SPAN CLASS="ERRMSG"><%= request.getAttribute("error.message") %></SPAN></TD></TR>

<%
	//handle any unbalanced parens
	String error = request.getParameter("error");
	if(error == null)
		error = "";
%>
<TR><TD><SPAN CLASS="ERRMSG"><%= error %></SPAN></TD></TR>


<TR><TD>

<TABLE CLASS="ENTRYBOX" BORDER=0 CELLSPACING=2>

<TR>
<TH></TH>
<TH>(</TH>
<TH><%= m_selectColumnLabel %></TH>
<TH><%= m_setOperationLabel %></TH>
<TH><%= m_enterValueLabel %></TH>
<TH>)</TH>
<TH><%= m_clearLabel %></TH>
</TR>

<%
   //#########    View of step two really begins here... ###############
   for (int i=0; i<linesToShow; i++) {
      BaseTransformation andOrChoicebox     = (BaseTransformation)request.getAttribute("item"+i+".link");
      BaseTransformation columnChoicebox    = (BaseTransformation)request.getAttribute("item"+i+".column");
      BaseTransformation notCheckbox        = (BaseTransformation)request.getAttribute("item"+i+".not");
      BaseTransformation conditionalChoicebox   = (BaseTransformation)request.getAttribute("item"+i+".operator");
      BaseTransformation valueTextEntry     = (BaseTransformation)request.getAttribute("item"+i+".operand1");
      
      BaseTransformation openParen = (BaseTransformation)request.getAttribute("item"+i+".openparen");
      BaseTransformation closeParen     = (BaseTransformation)request.getAttribute("item"+i+".closeparen");
%>
<TR>
<TD><% if (i>0) andOrChoicebox.write(out); %></TD>


<TD><% openParen.write(out); %></TD>


<TD><% columnChoicebox.write(out); %></TD>

<TD NOWRAP><%
   notCheckbox.write(out);
   conditionalChoicebox.write(out);
%></TD>


<TD NOWRAP><%
   valueTextEntry.write(out);
   String valueErrorMsg = (String)request.getAttribute("item"+i+".err");
   if (valueErrorMsg != null && valueErrorMsg.trim().length() > 0) {
      out.println("<SPAN CLASS=\"ERRMSG\">"+valueErrorMsg+"</SPAN>");
   }
%>
   <INPUT TYPE=BUTTON CLASS=BUTTON TITLE="<%= htmlEncode(m_valuesTipText) %>"
   VALUE="<%= htmlEncode(m_valuesButtonLabel) %>" OnClick="ShowValues(<%= i %>)">
</TD>


<TD><% closeParen.write(out); %></TD>


<TD ALIGN=CENTER>
   <INPUT TYPE=BUTTON CLASS=BUTTON TITLE="<%= htmlEncode(m_clearTipText) %>"
   VALUE="<%= htmlEncode(m_clearButtonLabel) %>" OnClick="ClearRow(<%= i %>)">
</TD>
</TR>

<%
   }
   if (!"y".equalsIgnoreCase(hideQueryLimit)) {
%>

<TR>
<TD ALIGN=LEFT COLSPAN=5>
    <%= m_queryLimit%> <INPUT type="text" name="queryObs" maxlength="200" size="10" VALUE="<%= queryObs %>"/> <%= m_queryLimitMsg %>
</TD>
</TR>

<%
	}
%>
     
<TR>
<TD ALIGN=LEFT COLSPAN=2>
   <INPUT TYPE=BUTTON CLASS=BUTTON TITLE="<%= htmlEncode(m_moreFiltersTipText) %>"
   VALUE="<%= m_moreFiltersLabel %>" OnClick="document.initQry.intAction.value='more'; initQry.submit();">
</TD>
<TD ALIGN=RIGHT COLSPAN=3>
<B><%= m_tipHelpLabel %></B>
<%= m_dateFormatTipText %>
</TD>
</TR>
</TABLE>
<BR><BR>

</FORM>

</TD>
</TR>

<SCRIPT>
function doNav(cmd) {
   document.initQry.intAction.value=cmd;
   document.initQry.submit();
}

function doOK() { doNav("ok"); }
function doCancel() { doNav("cancel"); }
function doSave() { doNav('goto.save'); }
</SCRIPT>
<TR> <TD> <jsp:include page="button_include.jsp" flush="true" /> </TD> </TR>
</TABLE>

</TD></TR>
</TABLE>    <!-- END WHOLE PAGE TABLE -->

</BODY>
</HTML>
