<%@page import="java.io.*,java.util.*" %>
<%@page import="com.sas.hrv.*" %>

<%
/*********************************************************************/
// Copyright (c) 2001 by SAS Institute Inc., Cary, NC 27513
/*********************************************************************/
//
// NAME:     changepass.jsp
// AUTHOR:   maperr - Matthew Perry
// SUPPORT:  maperr - Matthew Perry
// PRODUCT:  hrvision
// TYPE:     jsp page
// LANGUAGE: java
// PURPOSE:  jsp to allow user to change their password
//
// HISTORY:   Date    Who     Action
//           -------------------------------------------------------
//           19Apr01  maperr  initial coding
/*********************************************************************/
%>

<%@ include file="HRVLoginInclude.jsp"%>
<html>
<head>
<%@ include file="HRVHeadInclude.jsp"%>
<script language="JavaScript">
	function doSubmit()
	{
		document.PWDCHANGE.CMD.value='SAVE';
		document.PWDCHANGE.submit();
	}
	function doReset()
	{
		document.PWDCHANGE.CMD.value='RESET';
		document.PWDCHANGE.submit();
	} 
</script>
</head>

<%
	UserBean userBean = null;
	VisMsg vM = VisMsg.getInstance(session);
	CodeBean cB = HrvInfo.getCodeBean(session);
	userBean = new UserBean(session);
	
	String currentPrefName = cB.getUserAttributeValue("name");
	String currentEmail = cB.getUserAttributeValue("email");
	
	if(currentEmail == null)
		currentEmail = "";
	if(currentPrefName == null)
		currentPrefName = "";

	String CMD = request.getParameter("CMD");	
	String oldPwdMsg = vM.getLabel("CPCenterOldPassword");
	String newPwdMsg = vM.getLabel("CPCenterNewPassword");
	String verifyPwdMsg = vM.getLabel("CPCverifyNewPassword");
	String prefName = vM.getLabel("UserAttr_name.txt");
	String email = vM.getLabel("UserAttr_email.txt");
	String change = vM.getLabel("CPCchangePwd");
	String userAttribute = vM.getLabel("UAT_UPDATECONFIRM.txt");
	String pageHeader = vM.getLabel("MENU_CONFIGUREchangepass.txt");
	String userPassword = vM.getLabel("CPCtitle.txt");
	String errorMessage = "<font color=\"white\"> Blank Space </font>";
	int i = 0;
	
	String browserType = (String)hrvi.getBrowserType(session);
	int borderType = 0;
	if(!browserType.equalsIgnoreCase("IE"))
		borderType = 1;
		
		
		
	String enteredEmail = request.getParameter("email");
	if(enteredEmail != null && !CMD.equals("RESET"))
		currentEmail = enteredEmail;
		
	String enteredPrefName = request.getParameter("prefName");
	if(enteredPrefName != null && !CMD.equals("RESET"))
		currentPrefName = enteredPrefName;
%> 

<body onload="document.PWDCHANGE.prefName.focus();" class="bodyContents">
<%out.println("<H1><CENTER>" + pageHeader + "</H1></CENTER>");%>

<form name="PWDCHANGE" method="post" action="changepassc.jsp">
<table border="0" width="100%" height="100%"> 

	<tr align="CENTER"><td valign="CENTER">
	<b><%=userAttribute%></b>
	<table><tr><td>
	<table class="ENTRYBOX" border="<%=borderType%>"  cellspacing=2 cellpadding=5 width=450>
		<tr>
			<td align=right><%=prefName%>:</td>
			<td align=right><input type="text" name="prefName" value="<%=currentPrefName%>" size=32></td>
		</tr>
		<tr>
			<td align=right><%=email%>:</td>
			<td align=right><input type="text" name="email" value="<%=currentEmail%>" size=32></td>
		</tr>
	</table>
	</td></tr>
	<tr><td>
	<br>
	<center><b><%=userPassword%></b>
	<table class="ENTRYBOX" border="<%=borderType%>"  cellspacing=2 cellpadding=5 width=450>
		<tr>
			<td align=right><%=oldPwdMsg%></td>
			<td align=right><input type=password name=oldPass size=32 maxlength=16></td>
		</tr>
		<tr>
			<td align=right><%=newPwdMsg%></td>
			<td align=right><input type=password name=newPass size=32 maxlength=16></td>
		</tr>
		<tr>
			<td align=right><%=verifyPwdMsg%></td>
			<td align=right><input type=password name=verifyPass size=32 maxlength=16></td>
		</tr>
	</table>

&nbsp;
<input type="hidden" name="CMD" value="">
</form>

<%
	
	if(CMD == null || CMD.equalsIgnoreCase("SAVE"))
	{
		String oldPass = request.getParameter("oldPass");
		String newPass = request.getParameter("newPass");
		String verifyPass = request.getParameter("verifyPass");
		
		
		if(oldPass == null)
			oldPass = "";
		if(newPass == null)
			newPass = "";
		if(verifyPass == null)
			verifyPass = "";
			
		if(enteredEmail != null){
			//change the users email
			cB.setUserAttributeValue("email" , enteredEmail);
			cB.writeUser();
			errorMessage = vM.getSentence("passwordChangeComplete.txt");
		}
		
		if(enteredPrefName != null){
			cB.setUserAttributeValue("name" , enteredPrefName);
			cB.writeUser();
			errorMessage = vM.getSentence("passwordChangeComplete.txt");
		}
		
		if(!oldPass.equals("") && !newPass.equals("")){
                        //encrypt the entered password to check against saved
			oldPass = userBean.encrypt(oldPass);
			String currentPassword = cB.getUserAttributeValue("encryptpw");		
                        ValidatePassword vp = new ValidatePassword(session, newPass);

                        //verifiy that the new password is the same in both places
			if(!(newPass == verifyPass || newPass.equals(verifyPass))){	
				errorMessage = "<p class=\"errmsg\">" + vM.getSentence("passwordNotVerified.txt") + "</p>";
			}			

                        // check to see if the new password is a valid password
                        else if (!(vp.isValid())){
				errorMessage = "<p class=\"errmsg\">" + vp.getErrorMessages() + "</p>";
			}
			
			// the new password cannot be the same as the old password
			else if(!(currentPassword == oldPass || currentPassword.equals(oldPass))){	
				errorMessage = "<p class=\"errmsg\">" + vM.getSentence("oldPasswordInvalid.txt") + "</p>";
			}

			
			// everything is fine, encrypt the new password and make the change 
			else if(newPass != null && !newPass.equals("")){	
				newPass = userBean.encrypt(newPass);
				cB.setUserAttributeValue("encryptpw",newPass);
				cB.writeUser();
				errorMessage = vM.getSentence("passwordChangeComplete.txt");
			}	
		}
	}	
%>
<%=errorMessage%>
</td></tr>
</table>
</body>
</html>
<%
	String oldPass = "";
	String newPass = "";
	String verifyPass = "";
%>